-- Copyright 2018, Visions
-- All rights reserved.

-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions are met:

    -- * Redistributions of source code must retain the above copyright
      -- notice, this list of conditions and the following disclaimer.
    -- * Redistributions in binary form must reproduce the above copyright
      -- notice, this list of conditions and the following disclaimer in the
      -- documentation and/or other materials provided with the distribution.
    -- * Neither the name of InfoReplacer nor the
      -- names of its contributors may be used to endorse or promote products
      -- derived from this software without specific prior written permission.

-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
-- DISCLAIMED. IN NO EVENT SHALL Cairthenn BE LIABLE FOR ANY
-- DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
-- (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
-- LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
-- ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-- (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-- SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--
--英語名で入力された魔法、アビ、WSコマンドを日本語名に変えて送信する。
--

_addon.author = 'Visions'
_addon.name = 'magicReplace'
_addon.version = '0.71'
_addon.commands = {'magicreplace','mr'}

res = require('resources')
require('lists') ;

windower.register_event('outgoing text', function(original,modified,blocked)

	local result = modified ;
	
	if L{"/ma ","/mag","/job","/ja ","/ws ","/wea","/ite","/son"}:contains(result:sub(1,4)) then
		result = spell_e2j(result)  ;
	end
	return result ;
end)

function spell_e2j( command )
	local result = command ;
	local target = ""
		
	local comprefix = command:sub(1,command:find(" "),1) ;
	local magicname = getMagicname(command) ;

	if command:len() > command:find(magicname,1,1)+magicname:len() then 
		target = command:gsub("  "," "):sub( command:find(" ",command:find(magicname,1,1)+magicname:len() )+1,100 ) ;
	end
	if ( target:gsub(" ","") == "" ) then	--Targetがない場合は<me>にする
		target = "<me>"
	end
	
	if ( target:find("^%d+$") ) == nil then	--Targetが数字のみ＝メニューから魔法を使用した場合
		local act ;	
		if L{"/ma ","/magic ","/song "}:contains(comprefix) then 
			act = res.spells:with('english',magicname) ;
		elseif  L{"/ws ","/weaponskill "}:contains(comprefix) then 
			act = res.weapon_skills:with('english',magicname) ;
		elseif  L{"/ja ","/jobability "}:contains(comprefix) then 
			act = res.job_abilities:with('english',magicname) ;
		elseif comprefix == "/item " then
			act = res.items:with('english',magicname) ;
		end
		
		local act_name = ""
		if act == nil then
			act_name = magicname
		else
			act_name = windower.to_shift_jis(act.ja)
		end
		result = comprefix .. act_name .. " " .. target ;
	
		return result ;
	end
end

function getMagicname( command )
	local magicname = ""
	command = command .. " " --ターゲット未指定対策
	
	if #(command:split("\"")) == 3 then
		magicname = ( command:sub( command:find("\"")+1, command:find("\"",command:find("\"")+1) - 1 ) )
	else
		magicname = ( command:sub( command:find(" ") + 1, command:find(" ",command:find(" ") + 1) - 1 ) )
	end
	return magicname
end

--コマンド受付
windower.register_event('addon command', function (arg1,arg2)

	if arg1 == 'debug' then
		--local com = term:sub(term:find(",")+1,100)
		windower.add_to_chat(207,windower.convert_auto_trans(arg2))
		windower.add_to_chat(207,"Term: " .. arg1 .." Input: " .. arg2)
		--sjis(arg2)
		--local result = spell_e2j(arg2)
		--windower.add_to_chat(207,"Output: " .. result)
		
		--windower.add_to_chat(207,string.concat(arg2:byte(1,-1)," "))
--		windower.add_to_chat(207,arg2:byte(1,-1))

		print(arg2:byte(1,-1))
		print(windower.convert_auto_trans(arg2):byte(1,-1))
		
	else
		local text = windower.convert_auto_trans(arg1)	--タブ変換の場合は文字列に戻す
		local spell = res.spells:with('ja',windower.from_shift_jis(text))
		if spell == nil then
			spell = res.spells:with('english',text)
		end
		if spell == nil then
			spell = res.weapon_skills:with('ja',windower.from_shift_jis(text))
		end		
		if spell == nil then
			spell = res.weapon_skills:with('english',text)
		end		
		if spell == nil then
			spell = res.job_abilities:with('ja',windower.from_shift_jis(text))
		end		
		if spell == nil then
			spell = res.job_abilities:with('english',text)
		end
		if spell == nil then
			spell = res.items:with('ja',windower.from_shift_jis(text))
		end		
		if spell == nil then
			spell = res.items:with('english',text)
		end
		
		if  spell then
			windower.add_to_chat(207,"MagicReplace: ID:" .. spell.id .. " " .. windower.to_shift_jis(spell.ja) .. " \"" .. spell.english .."\"")
		end
	end
end)
